#include "bon_sem.h"
#include "bonnie.h"
#include <stdio.h>
#include <errno.h>

int BonSem::clear_sem()
{
  int semid;
  if((semid = semget(SemKey, NumSems, m_semflg)) == -1)
  {
    perror("semget: semget failed.\n");
    return 1;
  }
  if(semctl(semid, 0, IPC_RMID, m_arg) == -1)
  {
    perror("semctl: semctl SETVAL failed.\n");
    return 1;
  }
  printf("Semaphore removed.\n");
  return 0;
}

int BonSem::create(int sems)
{
  if((m_semid = semget(SemKey, NumSems, m_semflg)) == -1)
  {
    perror("semget: semget failed.\n");
    return 1;
  }
  m_arg.val = sems;
  int i;
  for(i = 0; i < NumSems; ++i)
  {
    if(semctl(m_semid, i, SETVAL, m_arg) == -1)
    {
      perror("semctl: semctl SETVAL failed.\n");
      return 1;
    }
  }
  printf("Number of process set to %d\n", sems);
  m_semopen = true;
  return 0;
}

int BonSem::get_semid()
{
  int semflg = 0666;
  if ((m_semid = semget(SemKey, NumSems, semflg)) == -1)
  {
    perror("semget: semget failed.\n");
    return 1;
  }
  m_semopen = true;
  return 0;
}

int BonSem::decrement_and_wait(int nr_sem)
{
  if(!m_semopen)
    return 0;
  struct sembuf sops;
  int nops = 1;
  sops.sem_num = nr_sem;
  sops.sem_op = -1;
  sops.sem_flg = IPC_NOWAIT;
  if(semop(m_semid, &sops, nops) == -1)
  {
    perror("semop: semop failed.\n");
    return 1;
  }
  sops.sem_num = nr_sem;
  sops.sem_op = 0;
  sops.sem_flg = SEM_UNDO;
  if(semop(m_semid, &sops, nops) == -1)
  {
    perror("semop: semop failed.\n");
    return 1;
  }
  return 0;
}
